-- Vector addition
function vAdd(v1, v2)
    return vec3(v1.x + v2.x, v1.y + v2.y, v1.z + v2.z)
end

-- Vector subtraction
function vSub(v1, v2)
    return vec3(v1.x - v2.x, v1.y - v2.y, v1.z - v2.z)
end

-- Vector multiplication by a scalar
function vMulS(v, scalar)
    return vec3(v.x * scalar, v.y * scalar, v.z * scalar)
end

-- Vector division by a scalar
function vDivS(v, scalar)
    assert(scalar ~= 0, "Division by zero!")
    return vec3(v.x / scalar, v.y / scalar, v.z / scalar)
end

-- Element-wise multiplication of two vectors
function vMul(v1, v2)
    return vec3(v1.x * v2.x, v1.y * v2.y, v1.z * v2.z)
end

-- Element-wise division of two vectors
function vDiv(v1, v2)
    return vec3(v1.x / v2.x, v1.y / v2.y, v1.z / v2.z)
end
